-----------------------------------------------------------------------------------------------
-- Client Lua Script for GotHUD
-- Copyright (c) NCsoft. All rights reserved
-----------------------------------------------------------------------------------------------
 
require "Window"
 
-----------------------------------------------------------------------------------------------
-- GotHUD Module Definition
-----------------------------------------------------------------------------------------------
local GotHUD = {} 
GotHUD.self = nil

local cassPkg = nil

GotHUD.HUDStyles = {
-- "default" styles
	{"", nil, nil, 0.0},   	-- blank style, primarily for use of text information	
	{"IceHUD Glow Arc Left", "gothud_GlowArcLeft", "gothud_GlowArcLeft", 0.25},
	{"IceHUD Glow Arc Right", "gothud_GlowArcRight", "gothud_GlowArcRight", 0.25},

	{"Combo", "gothud_Combo", "gothud_ComboBG", 0.75},
	{"Combo Clean Curves", "gothud_ComboCleanCurves", "gothud_ComboCleanCurvesBG", 0.75},
	{"Combo Glow", "gothud_ComboGlow", "gothud_ComboGlowBG", 0.75},
	{"Combo Round", "gothud_ComboRound", "gothud_ComboRoundBG", 0.75},
	
	{"Solid Rectangle", "gothud_Solid", nil, 0.75},

	{"Horizontal Basic Small", "gothud_HorizontalBasicSmall", "gothud_HorizontalBasicSmallBG", 0.75},
	{"Horizontal Basic Medium", "gothud_HorizontalBasicMedium", "gothud_HorizontalBasicMediumBG", 0.75},
	{"Horizontal Basic Large", "gothud_HorizontalBasicLarge", "gothud_HorizontalBasicLargeBG", 0.75},
	{"Horizontal Bar", "gothud_HorizontalRivetBar", "gothud_HorizontalRivetBar", 0.25},
	{"Horizontal Rivet Bar", "gothud_HorizontalRivetBar", "gothud_HorizontalRivetBarBG", 0.75},
	{"Horizontal Rivet Half Bar", "gothud_HorizontalRivetHalfBar", "gothud_HorizontalRivetHalfBarBG", 0.75},
	{"Horizontal Splash Bar", "gothud_HorizontalColorBar", "gothud_HorizontalColorBarBG", 0.4},
	{"Horizontal Rune Bar", "gothud_HorizontalRuneBar", "gothud_HorizontalRuneBarBG", 0.75},
	{"Horizontal Solid Rectangle", "gothud_HorizontalSolid", nil, 0.75},

	{"DHUD Bricks Crisp Left", "gothud_DHUD13Left", "gothud_DHUDBG1Left", 0.7},
	{"DHUD Bricks Crisp Right", "gothud_DHUD13Right", "gothud_DHUDBG1Right", 0.7},
	{"DHUD Bricks Soft Left", "gothud_DHUD13Left", "gothud_DHUDBG2Left", 0.4},
	{"DHUD Bricks Soft Right", "gothud_DHUD13Right", "gothud_DHUDBG2Right", 0.4},
	{"DHUD Bubbles Beveled Left", "gothud_DHUDLeft", "gothud_DHUDBGLeft", 0.7},
	{"DHUD Bubbles Beveled Right", "gothud_DHUDRight", "gothud_DHUDBGRight", 0.7},
	{"DHUD Bubbles Crisp Left", "gothud_DHUD12Left", "gothud_DHUDBG1Left", 0.7},
	{"DHUD Bubbles Crisp Right", "gothud_DHUD12Right", "gothud_DHUDBG1Right", 0.7},
	{"DHUD Bubbles Soft Left", "gothud_DHUD12Left", "gothud_DHUDBG2Left", 0.4},
	{"DHUD Bubbles Soft Right", "gothud_DHUD12Right", "gothud_DHUDBG2Right", 0.4},
	{"DHUD Gradient Crisp Left", "gothud_DHUD11Left", "gothud_DHUDBG1Left", 0.7},
	{"DHUD Gradient Crisp Right", "gothud_DHUD11Right", "gothud_DHUDBG1Right", 0.7},
	{"DHUD Gradient Soft Left", "gothud_DHUD11Left", "gothud_DHUDBG2Left", 0.4},
	{"DHUD Gradient Soft Right", "gothud_DHUD11Right", "gothud_DHUDBG2Right", 0.4},
	{"DHUD Marble Crisp Left", "gothud_DHUD15Left", "gothud_DHUDBG1Left", 0.7},
	{"DHUD Marble Crisp Right", "gothud_DHUD15Right", "gothud_DHUDBG1Right", 0.7},
	{"DHUD Marble Soft Left", "gothud_DHUD15Left", "gothud_DHUDBG2Left", 0.4},
	{"DHUD Marble Soft Right", "gothud_DHUD15Right", "gothud_DHUDBG2Right", 0.4},
	{"DHUD Texture Crisp Left", "gothud_DHUD14Left", "gothud_DHUDBG1Left", 0.7},
	{"DHUD Texture Crisp Right", "gothud_DHUD14Right", "gothud_DHUDBG1Right", 0.7},
	{"DHUD Texture Soft Left", "gothud_DHUD14Left", "gothud_DHUDBG2Left", 0.4},
	{"DHUD Texture Soft Right", "gothud_DHUD14Right", "gothud_DHUDBG2Right", 0.4},
	{"IceHUD Arc Left", "gothud_ArcHUDLeft", "gothud_ArcHUDBGLeft", 0.25},
	{"IceHUD Arc Right", "gothud_ArcHUDRight", "gothud_ArcHUDBGRight", 0.25},
	{"IceHUD Bar Left", "gothud_BarLeft", "gothud_BarBGLeft", 0.25},
	{"IceHUD Bar Right", "gothud_BarRight", "gothud_BarBGRight", 0.25},
	{"IceHUD Blood Glaives Left", "gothud_BloodGlaivesLeft", "gothud_BloodGlaivesBGLeft", 0.8},
	{"IceHUD Blood Glaives Right", "gothud_BloodGlaivesRight", "gothud_BloodGlaivesBGRight", 0.8},
	{"IceHUD Curves Left", "gothud_CleanCurvesLeft", "gothud_CleanCurvesBGLeft", 0.4},
	{"IceHUD Curves Right", "gothud_CleanCurvesRight", "gothud_CleanCurvesBGRight", 0.4},
	{"IceHUD CurvesOut Left", "gothud_CleanCurvesOutLeft", "gothud_CleanCurvesOutBGLeft", 0.75},
	{"IceHUD CurvesOut Right", "gothud_CleanCurvesOutRight", "gothud_CleanCurvesOutBGRight", 0.75},
	{"IceHUD Fang Rune Left", "gothud_FangRuneLeft", "gothud_FangRuneBGLeft", 0.5},
	{"IceHUD Fang Rune Right", "gothud_FangRuneRight", "gothud_FangRuneBGRight", 0.5},
	{"IceHUD HiBar Left", "gothud_HiBarLeft", "gothud_HiBarBGLeft", 0.9},
	{"IceHUD HiBar Right", "gothud_HiBarRight", "gothud_HiBarBGRight", 0.9},
	{"IceHUD Rivet Left", "gothud_RivetBarLeft", "gothud_RivetBarBGLeft", 0.75},
	{"IceHUD Rivet Right", "gothud_RivetBarRight", "gothud_RivetBarBGRight", 0.75},
	{"IceHUD Rivet Thick Left", "gothud_RivetBar2Left", "gothud_RivetBar2BGLeft", 0.75},
	{"IceHUD Rivet Thick Right", "gothud_RivetBar2Right", "gothud_RivetBar2BGRight", 0.75},
	{"IceHUD Round Bar Left", "gothud_RoundBarLeft", "gothud_RoundBarBGLeft", 0.5},
	{"IceHUD Round Bar Right", "gothud_RoundBarRight", "gothud_RoundBarBGRight", 0.5},
	{"IceHUD Rune Bar Left", "gothud_RuneBarLeft", "gothud_RuneBarBGLeft", 0.75},
	{"IceHUD Rune Bar Right", "gothud_RuneBarRight", "gothud_RuneBarBGRight", 0.75},
	{"IceHUD Soft Glow Arc Left", "gothud_GlowArcLeft", "gothud_GlowArcBGLeft", 0.75},
	{"IceHUD Soft Glow Arc Right", "gothud_GlowArcRight", "gothud_GlowArcBGRight", 0.75},
	{"IceHUD Splash Bar Left", "gothud_ColorBarLeft", "gothud_ColorBarBGLeft", 0.4},
	{"IceHUD Splash Bar Right", "gothud_ColorBarRight", "gothud_ColorBarBGRight", 0.4}
}

GotHUD.CodeEnumResource = {
	Health = 1,
	Shield = 2,
	Absorb = 3,
	ShieldAndAbsorb = 4,
	Combined = 5,	
	Sprint = 6,
	ClassPrimary = 7,
	ClassSecondary = 8,
	DashCharges = 9,
	DashPercent = 10,
	CastTimer = 11,
	InterruptArmor = 12,
	LevelXP = 17,
	PathXP = 18,
	Constant = 19,
	Level = 20,
	Name = 21,
	PathLevel = 25,
	CastName = 500,

	TargetHealth = 13,
	TargetShield = 14,
	TargetCastTimer = 15,
	TargetInterruptArmor = 16,
	TargetConstant = 22,
	TargetLevel = 23,
	TargetName = 24,
	TargetCastName = 600,
	
	Pet1Health = 101,
	Pet1Shield = 102,
	Pet1Absorb = 103,
	Pet1ShieldAndAbsorb = 104,
	Pet1Combined = 105,	
	Pet1CastTimer = 106,
	Pet1CastName = 110,
	Pet1Constant = 107,
	Pet1Level = 108,
	Pet1Name = 109,
	
	Pet2Health = 151,
	Pet2Shield = 152,
	Pet2Absorb = 153,
	Pet2ShieldAndAbsorb = 154,
	Pet2Combined = 155,	
	Pet2CastTimer = 156,
	Pet2Constant = 157,
	Pet2Level = 158,
	Pet2Name = 159,	
	Pet2CastName = 160
	
}
GotHUD.CodeEnumResourceStrings = {
    [GotHUD.CodeEnumResource.Health] = "Player Health",
    [GotHUD.CodeEnumResource.Shield] = "Player Shield",
    [GotHUD.CodeEnumResource.Absorb] = "Player Absorb",
    [GotHUD.CodeEnumResource.ShieldAndAbsorb] = "Player Shield & Absorb",
    [GotHUD.CodeEnumResource.Combined] = "Player Health & Shield",
    [GotHUD.CodeEnumResource.Sprint] = "Player Sprint",
    [GotHUD.CodeEnumResource.ClassPrimary] = "Player Primary Class Resource",
    [GotHUD.CodeEnumResource.ClassSecondary] = "Player Secondary Class Resource",
    [GotHUD.CodeEnumResource.DashCharges] = "Player Dash Charges",
    [GotHUD.CodeEnumResource.DashPercent] = "Player Dash Percent",
    [GotHUD.CodeEnumResource.CastTimer] = "Player Cast Timer",
    [GotHUD.CodeEnumResource.CastName] = "Player Cast Name",
    [GotHUD.CodeEnumResource.InterruptArmor] = "Player Interrupt Armor",

	[GotHUD.CodeEnumResource.TargetHealth] = "Target Health",
	[GotHUD.CodeEnumResource.TargetShield] = "Target Shield",
	[GotHUD.CodeEnumResource.TargetCastTimer] = "Target Cast Timer",
    [GotHUD.CodeEnumResource.TargetCastName] = "Target Cast Name",
	[GotHUD.CodeEnumResource.TargetInterruptArmor] = "Target Interrupt Armor",
	
	[GotHUD.CodeEnumResource.LevelXP] = "Player Level XP",
	[GotHUD.CodeEnumResource.PathXP] = "Player Path XP",
	[GotHUD.CodeEnumResource.Constant] = "Player Constant",
	[GotHUD.CodeEnumResource.Level] = "Player Level",
	[GotHUD.CodeEnumResource.Name] = "Player Name",
	[GotHUD.CodeEnumResource.TargetConstant] = "Target Constant",
	[GotHUD.CodeEnumResource.TargetLevel] = "Target Level",
	[GotHUD.CodeEnumResource.TargetName] = "Target Name",
	[GotHUD.CodeEnumResource.PathLevel] = "Player Path Level",

	[GotHUD.CodeEnumResource.Pet1Health] = "Pet1 Health",
	[GotHUD.CodeEnumResource.Pet1Shield] = "Pet1 Shield",
	[GotHUD.CodeEnumResource.Pet1Absorb] = "Pet1 Absorb",
	[GotHUD.CodeEnumResource.Pet1ShieldAndAbsorb] = "Pet1 Shield & Absorb",
	[GotHUD.CodeEnumResource.Pet1Combined] = "Pet1 Health & Shield",	
	[GotHUD.CodeEnumResource.Pet1CastTimer] = "Pet1 Cast Timer",
	[GotHUD.CodeEnumResource.Pet1CastName] = "Pet1 Cast Name",
	[GotHUD.CodeEnumResource.Pet1Constant] = "Pet1 Constant",
	[GotHUD.CodeEnumResource.Pet1Level] = "Pet1 Level",
	[GotHUD.CodeEnumResource.Pet1Name] = "Pet1 Name",
	
	[GotHUD.CodeEnumResource.Pet2Health] = "Pet2 Health",
	[GotHUD.CodeEnumResource.Pet2Shield] = "Pet2 Shield",
	[GotHUD.CodeEnumResource.Pet2Absorb] = "Pet2 Absorb",
	[GotHUD.CodeEnumResource.Pet2ShieldAndAbsorb] = "Pet2 Shield & Absorb",
	[GotHUD.CodeEnumResource.Pet2Combined] = "Pet2 Health & Shield",	
	[GotHUD.CodeEnumResource.Pet2CastTimer] = "Pet2 Cast Timer",
	[GotHUD.CodeEnumResource.Pet2Constant] = "Pet2 Constant",
	[GotHUD.CodeEnumResource.Pet2Level] = "Pet2 Level",
	[GotHUD.CodeEnumResource.Pet2Name] = "Pet2 Name",
	[GotHUD.CodeEnumResource.Pet2CastName] = "Pet2 Cast Name",
}

GotHUD.CodeEnumTextFormat = {
	Percent = 1,	-- 57%  cur/max * 100 %
	Decimal = 2,	-- 0.57 cur/max
	Raw = 3,		-- 5700 cur
	Unit = 4		-- 5.7k cur/1000 k
}
GotHUD.CodeEnumHUDPosition = {
	Left = 1,
	Right = 2,
	Top = 3,
	Bottom = 4
}

--GotHUD.CodeEnumOffsets = {-128,-256, 128, 256}
GotHUD.CodeEnumTextOffsets = {-126,-25,126,25}
GotHUD.CodeEnumOffsets = {-64,-128, 64, 128}
--GotHUD.CodeEnumTextOffsets = {-15,-10,15,10}

GotHUD.CodeEnumShowHUD = {
	Never = 1,
	Always = 2,
	InCombatOnly = 3,
	OutCombatOnly = 4
}

GotHUD.TemplateHUD = {
	style = GotHUD.HUDStyles[2],
	discreteThreshold = 0,
	resource = GotHUD.CodeEnumResource.Health,
	show = GotHUD.CodeEnumShowHUD.Always,
	hideAbove = 1.0,
	hideBelow = 0.0,
	verticalOffset = 0,    -- positive is down
	horizontalOffset = -150,  -- positive is right
	lock = true,
	scale = 1.0,
	rotation = 0,
	opacity = 0.625,
	colorFull = "ff00ff00",
	colorEmpty = "ffff0000",
	colorFrame = "ffffffff",
	showText = false,
	verticalOffsetText = 140,    -- positive is down
	horizontalOffsetText = 50,  -- positive is right
	textFormat = GotHUD.CodeEnumTextFormat.Percent,
	textFont = "CRB_Pixel",
	colorText = "ffffffff",
	wnd = nil
}

GotHUD.DefaultHUD = {
	["Default Health"] = {
		style = GotHUD.HUDStyles[2],
		discreteThreshold = 0,
		resource = GotHUD.CodeEnumResource.Health,
		show = GotHUD.CodeEnumShowHUD.Always,
		hideAbove = 1.0,
		hideBelow = 0.0,
		verticalOffset = 0,    -- positive is down
		horizontalOffset = -150,  -- positive is right
		lock = true,
		scale = 1.0,
		rotation = 0,
		opacity = 0.625,
		colorFull = "ff00ff00",
		colorEmpty = "ffff0000",
		colorFrame = "ffffffff",
		showText = false,
		verticalOffsetText = 140,    -- positive is down
		horizontalOffsetText = 50,  -- positive is right
		textFormat = GotHUD.CodeEnumTextFormat.Percent,
		textFont = "CRB_Pixel",
		colorText = "ffffffff",
		wnd = nil
	},
	["Default Shield"] = {
		style = GotHUD.HUDStyles[2],
		discreteThreshold = 0,
		resource = GotHUD.CodeEnumResource.ShieldAndAbsorb,
		show = GotHUD.CodeEnumShowHUD.Always,
		hideAbove = 1.0,
		hideBelow = 0.0,
		verticalOffset = 0,    -- positive is down
		horizontalOffset = -170,  -- positive is right
		lock = true,
		rotation = 0,
		scale = 1.0,
		opacity = 0.625,
		colorFull = "ff0000ff",
		colorEmpty = "ff0000ff",
		colorFrame = "ffffffff",
		showText = false,
		verticalOffsetText = 140,    -- positive is down
		horizontalOffsetText = 50,  -- positive is right
		textFormat = GotHUD.CodeEnumTextFormat.Unit,
		textFont = "CRB_Pixel",
		colorText = "ffffffff",
		wnd = nil
	},	
	["Default Class Resource"] = {
		style = GotHUD.HUDStyles[3],
		discreteThreshold = 0,
		resource = GotHUD.CodeEnumResource.ClassPrimary,
		show = GotHUD.CodeEnumShowHUD.Always,
		hideAbove = 1.0,
		hideBelow = 0.0,
		verticalOffset = 0,    -- positive is down
		horizontalOffset = 150,  -- positive is right
		lock = true,
		scale = 1.0,
		rotation = 0,
		opacity = 0.625,
		colorFull = "ffff0000",
		colorEmpty = "ffff0000",
		colorFrame = "ffffffff",
		showText = true,
		verticalOffsetText = 140,    -- positive is down
		horizontalOffsetText = -50,  -- positive is right
		textFormat = GotHUD.CodeEnumTextFormat.Percent,
		textFont = "CRB_Pixel",
		colorText = "ffffffff",
		wnd = nil
	},
	["Default Sprint"] = {
		style = GotHUD.HUDStyles[3],
		discreteThreshold = 0,
		resource = GotHUD.CodeEnumResource.Sprint,
		show = GotHUD.CodeEnumShowHUD.Always,
		hideAbove = 0.99,
		hideBelow = 0.0,
		verticalOffset = 0,    -- positive is down
		horizontalOffset = 170,  -- positive is right
		lock = true,
		scale = 1.0,
		rotation = 0,
		opacity = 0.625,
		colorFull = "ffffffff",
		colorEmpty = "ffffffff",
		colorFrame = "ffffffff",
		showText = false,
		verticalOffsetText = 140,    -- positive is down
		horizontalOffsetText = -50,  -- positive is right
		textFormat = GotHUD.CodeEnumTextFormat.Percent,
		textFont = "CRB_Pixel",
		colorText = "ffffffff",
		wnd = nil
	},	
	["Default Dash Percent"] = {
		style = GotHUD.HUDStyles[3],
		discreteThreshold = 0,
		resource = GotHUD.CodeEnumResource.DashPercent,
		show = GotHUD.CodeEnumShowHUD.Always ,
		hideAbove = 0.99,
		hideBelow = 0.0,
		verticalOffset = 0,    -- positive is down
		horizontalOffset = 190,  -- positive is right
		lock = true,
		scale = 1.0,
		rotation = 0,
		opacity = 0.625,
		colorFull = "ffFF00FF",
		colorEmpty = "ffFF00FF",
		colorFrame = "ffffffff",
		showText = false,
		verticalOffsetText = 140,    -- positive is down
		horizontalOffsetText = -50,  -- positive is right
		textFormat = GotHUD.CodeEnumTextFormat.Percent,
		textFont = "CRB_Pixel",
		colorText = "ffffffff",
		wnd = nil
	},
	["Default Dash Charges"] = {
		style = GotHUD.HUDStyles[1],
		discreteThreshold = 0,
		resource = GotHUD.CodeEnumResource.DashCharges,
		show = GotHUD.CodeEnumShowHUD.Always ,
		hideAbove = 0.99,
		hideBelow = 0.0,
		verticalOffset = 0,    -- positive is down
		horizontalOffset = 190,  -- positive is right
		lock = true,
		scale = 1.0,
		rotation = 0,
		opacity = 0.625,
		colorFull = "ffFF00FF",
		colorEmpty = "ffFF00FF",
		colorFrame = "ffffffff",
		showText = true,
		verticalOffsetText = 140,    -- positive is down
		horizontalOffsetText = -50,  -- positive is right
		textFormat = GotHUD.CodeEnumTextFormat.Raw,
		textFont = "CRB_Pixel",
		colorText = "ffffffff",
		wnd = nil
	}
}
-----------------------------------------------------------------------------------------------
-- Constants
-----------------------------------------------------------------------------------------------
-- e.g. local kiExampleVariableMax = 999

local userSettings = {}
local defaultSettings = {
	disable = false,
	fadeSettings = true,
	hudTable = GotHUD.DefaultHUD,
	hudOrder = {"Default Health","Default Shield","Default Class Resource","Default Sprint","Default Dash Percent","Default Dash Charges"}
}
 
-----------------------------------------------------------------------------------------------
-- Initialization
-----------------------------------------------------------------------------------------------
function GotHUD:new(o)
    o = o or {}
    setmetatable(o, self)
    self.__index = self 
    return o
end

function GotHUD:Init()
	local bHasConfigureFunction = true
	local strConfigureButtonText = "GotHUD?"
	local tDependencies = {
		"CassPkg-1.1"
	}
    Apollo.RegisterAddon(self, bHasConfigureFunction , strConfigureButtonText, tDependencies)
end



-----------------------------------------------------------------------------------------------
-- GotHUD OnLoad
-----------------------------------------------------------------------------------------------
function GotHUD:OnLoad()
	GotHUD.self = self
	cassPkg = Apollo.GetPackage("CassPkg-1.1").tPackage

	self.xmlDoc = XmlDoc.CreateFromFile("GotHUD.xml")
	self.xmlDoc:RegisterCallback("OnDocLoaded", self)

	self.playerUnit = nil
	self.targetUnit = nil
	self.playerInCombat = false
	self.editHud = nil

	userSettings = cassPkg.deepcopy(defaultSettings)
	
end

-----------------------------------------------------------------------------------------------
-- GotHUD OnDocLoaded
-----------------------------------------------------------------------------------------------
function GotHUD:OnDocLoaded()
	if self.xmlDoc ~= nil and self.xmlDoc:IsLoaded() then
	    self.wndMain = Apollo.LoadForm(self.xmlDoc, "GotHUDForm", nil, self)
		if self.wndMain == nil then
			Apollo.AddAddonErrorText(self, "Could not load the main window for some reason.")
			return
		end
		
	    self.wndMain:Show(false, true)

		-- Register handlers for events, slash commands and timer, etc.
		Apollo.RegisterEventHandler("NextFrame", 			"OnFrame", self)
		Apollo.RegisterEventHandler("UnitCreated", 			"OnUnitCreated", self)
		Apollo.RegisterEventHandler("ChangeWorld", 			"OnChangeWorld", self)
		Apollo.RegisterEventHandler("UnitEnteredCombat", 	"OnEnteredCombat", self)
		Apollo.RegisterTimerHandler("UpdateCastBarTimer", 	"OnFrame", self)
		Apollo.RegisterSlashCommand("gothud", 				"OnGotHUDOn", self)
		Apollo.RegisterSlashCommand("hud", 					"OnGotHUDOn", self)
		Apollo.LoadSprites("GotHUDSprites.xml", 			"HUDSprites")
		
	end
end

-----------------------------------------------------------------------------------------------
-- GotHUD Functions
-----------------------------------------------------------------------------------------------
-- Define general functions here
function GotHUD:GetClassResource(unit)
	local classID = unit:GetClassId()
	if classID == GameLib.CodeEnumClass.Engineer or classID == GameLib.CodeEnumClass.Warrior then
		return unit:GetResource(1), unit:GetMaxResource(1), 0, 1
	elseif classID == GameLib.CodeEnumClass.Stalker then
		return unit:GetResource(3), unit:GetMaxResource(3), 0, 1
	elseif classID == GameLib.CodeEnumClass.Esper then
		return unit:GetResource(1), 5,  unit:GetFocus(), unit:GetMaxFocus()
	elseif classID == GameLib.CodeEnumClass.Medic then
		return unit:GetResource(1), 4, unit:GetFocus(), unit:GetMaxFocus()
	elseif classID == GameLib.CodeEnumClass.Spellslinger then
		return unit:GetResource(4), unit:GetMaxResource(4), unit:GetFocus(), unit:GetMaxFocus()
	end
	return unit:GetFocus(),unit:GetMaxFocus(),0,1
end

function GotHUD:SetBarVars(bar, barWnd, curr, max)
	if tonumber(curr) == curr and tonumber(max) == max then
		barWnd:FindChild(bar):SetMax(max)
		barWnd:FindChild(bar):SetProgress(curr)
	else 
		barWnd:FindChild(bar):SetMax(1)
		barWnd:FindChild(bar):SetProgress(1)
	end
end

function GotHUD:FormatText(percentOfMax, raw, format)
	if raw == nil then
		return 0
	end
	if tonumber(raw) ~= raw then
		return raw
	end
	
	local text = ""
	if format == GotHUD.CodeEnumTextFormat.Percent then
		text = cassPkg.round(percentOfMax*100,0) .. "%"
	elseif format == GotHUD.CodeEnumTextFormat.Decimal then
		text = cassPkg.round(percentOfMax,5) .. ""
	elseif format == GotHUD.CodeEnumTextFormat.Raw then
		text = raw .. ""
	elseif format == GotHUD.CodeEnumTextFormat.Unit then
		text = raw .. ""
		if raw > 1000000 then
			text = cassPkg.round(raw/1000000,1) .. "m"
		elseif raw > 1000 then
			text = cassPkg.round(raw/1000,1) .. "k"
		end
	end
	
	return text
end

-- TODO - If performance becomes an issue, then we could grab only the resources there is an active hud for
-- i.e. 
function GotHUD:GetResourceData(unit)
	local currRP, maxRP, currRP2, maxRP2 = self:GetClassResource(unit)
	local shield = cassPkg.NullToZero(unit:GetShieldCapacity())
	local maxShield = cassPkg.NullToZero(unit:GetShieldCapacityMax())
	local health = cassPkg.NullToZero(unit:GetHealth())
	local maxHealth = cassPkg.NullToZero(unit:GetMaxHealth())
	local absorb = cassPkg.NullToZero(unit:GetAbsorptionValue())
	local maxAbsorb = cassPkg.NullToZero(unit:GetAbsorptionMax())
	local sprint = cassPkg.NullToZero(unit:GetResource(0))
	local maxSprint = cassPkg.NullToZero(unit:GetMaxResource(0))
	local interrupt = cassPkg.NullToZero(unit:GetInterruptArmorValue())
	local maxInterrupt = cassPkg.NullToZero(unit:GetInterruptArmorMax())

	local castElapsed = 0
	local castDuration = 1	-- default will be 1 so we don't get a division by zero
	local castName = ""
	if unit:IsCasting() then
		castDuration = unit:GetCastDuration()
		castElapsed = unit:GetCastElapsed()
		castName = unit:GetCastName()
	elseif self.wndMain ~= nil and self.wndMain:IsShown() then
		castName = "Casting a Spell..."
	end

	-- absorbs are pushing up the health past maximum?  Mmmkay.		
	if health > maxHealth then
		maxHealth = health 
	end
	if shield > maxShield then
		maxShield = shield
	end
	local shieldAndAbsorb = shield
	local maxShieldAndAborb = maxShield
	if absorb > 0 and maxAbsorb > 0  then
		shieldAndAbsorb = shield + absorb
		maxShieldAndAborb = maxShield+ maxAbsorb 
	end
	local combined = shield + health
	local maxCombined = maxHealth + maxShield
	
	local evade = unit:GetResource(7)
	local maxEvade = unit:GetMaxResource(7)
	local dashCharges = 0
	if evade >= maxEvade then -- all full
		dashCharges = 2 
	elseif math.floor(evade/100) < 1 then -- none ready
		dashCharges = 0 
	else -- one ready, one filling
		dashCharges = 1 
	end
	
	local level = unit:GetLevel()
	local maxLevel = 50
	local name = unit:GetName()
	
	-- path xp
	local nCurrentLevel = PlayerPathLib.GetPathLevel()
	local nNextLevel = math.min(30, nCurrentLevel + 1)
	local nLastLevelXP = PlayerPathLib.GetPathXPAtLevel(nCurrentLevel)
	local pathXP =  PlayerPathLib.GetPathXP() - nLastLevelXP
	local maxPathXP = PlayerPathLib.GetPathXPAtLevel(nNextLevel) - nLastLevelXP
	
	local currData = {
		[GotHUD.CodeEnumResource.Health] = health,
		[GotHUD.CodeEnumResource.Shield] = shield,
		[GotHUD.CodeEnumResource.Absorb] = absorb ,
		[GotHUD.CodeEnumResource.ShieldAndAbsorb] = shieldAndAbsorb ,
		[GotHUD.CodeEnumResource.Combined] = combined ,
		[GotHUD.CodeEnumResource.Sprint] = sprint,
		[GotHUD.CodeEnumResource.ClassPrimary] = currRP,
	    [GotHUD.CodeEnumResource.ClassSecondary] = currRP2,
		[GotHUD.CodeEnumResource.DashCharges] = dashCharges,
		[GotHUD.CodeEnumResource.DashPercent] = evade,
		[GotHUD.CodeEnumResource.CastTimer] = castElapsed,
		[GotHUD.CodeEnumResource.CastName] = castName,
		[GotHUD.CodeEnumResource.InterruptArmor] = interrupt,
		[GotHUD.CodeEnumResource.LevelXP] = GetXp() - GetXpToCurrentLevel(),
		[GotHUD.CodeEnumResource.PathXP] = pathXP,
		[GotHUD.CodeEnumResource.PathLevel] = nCurrentLevel,
		[GotHUD.CodeEnumResource.Constant] = 1,
		[GotHUD.CodeEnumResource.Level] = level,
		[GotHUD.CodeEnumResource.Name] = name
	}
	local maxData = {
		[GotHUD.CodeEnumResource.Health] = maxHealth,
		[GotHUD.CodeEnumResource.Shield] = maxShield,
		[GotHUD.CodeEnumResource.Absorb] = maxAbsorb ,
		[GotHUD.CodeEnumResource.ShieldAndAbsorb] = maxShieldAndAborb ,
		[GotHUD.CodeEnumResource.Combined] = maxCombined ,
		[GotHUD.CodeEnumResource.Sprint] = maxSprint,
		[GotHUD.CodeEnumResource.ClassPrimary] = maxRP,
	    [GotHUD.CodeEnumResource.ClassSecondary] = maxRP2,
		[GotHUD.CodeEnumResource.DashCharges] = 2,
		[GotHUD.CodeEnumResource.DashPercent] = maxEvade, 
		[GotHUD.CodeEnumResource.CastTimer] = castDuration,
		[GotHUD.CodeEnumResource.CastName] = castName,
		[GotHUD.CodeEnumResource.InterruptArmor] = maxInterrupt,
		[GotHUD.CodeEnumResource.LevelXP] = GetXpToNextLevel(),
		[GotHUD.CodeEnumResource.PathXP] = maxPathXP,
		[GotHUD.CodeEnumResource.PathLevel] = 30,
		[GotHUD.CodeEnumResource.Constant] = 1,
		[GotHUD.CodeEnumResource.Level] = maxLevel,
		[GotHUD.CodeEnumResource.Name] = name
	}
	
	return currData,maxData
end

function GotHUD:AppendTargetData(currData,maxData)
	local targetResources = { 
		[GotHUD.CodeEnumResource.TargetHealth] = GotHUD.CodeEnumResource.Health,
		[GotHUD.CodeEnumResource.TargetShield] = GotHUD.CodeEnumResource.ShieldAndAbsorb,
		[GotHUD.CodeEnumResource.TargetCastTimer] = GotHUD.CodeEnumResource.CastTimer,
		[GotHUD.CodeEnumResource.TargetCastName] = GotHUD.CodeEnumResource.CastName,
		[GotHUD.CodeEnumResource.TargetInterruptArmor] = GotHUD.CodeEnumResource.InterruptArmor,
		[GotHUD.CodeEnumResource.TargetConstant] = GotHUD.CodeEnumResource.Constant,
		[GotHUD.CodeEnumResource.TargetLevel] = GotHUD.CodeEnumResource.Level,
		[GotHUD.CodeEnumResource.TargetName] = GotHUD.CodeEnumResource.Name
	}
	if self.targetUnit ~= nil and self.targetUnit:IsValid() then
		local targetCurr, targetMax = self:GetResourceData(self.targetUnit)
		for t,r in pairs(targetResources) do
			currData[t] = targetCurr[r]
			maxData[t] = targetMax[r]
		end
	else
		for t,r in pairs(targetResources) do
			currData[t] = 0
			maxData[t] = 0 -- new change, if no targetunit is selected, the HUD will disappear
		end
	end
	return currData, maxData
end

function GotHUD:AppendPetData(currData,maxData)
	local petResources = { 
		["Health"] = GotHUD.CodeEnumResource.Health,
		["Shield"] = GotHUD.CodeEnumResource.Shield,
		["Absorb"] = GotHUD.CodeEnumResource.Absorb,
		["ShieldAndAbsorb"] = GotHUD.CodeEnumResource.ShieldAndAbsorb,
		["Combined"] = GotHUD.CodeEnumResource.Combined,
		["CastTimer"] = GotHUD.CodeEnumResource.CastTimer,
		["CastName"] = GotHUD.CodeEnumResource.CastName,
		["Constant"] = GotHUD.CodeEnumResource.Constant,
		["Level"] = GotHUD.CodeEnumResource.Level,
		["Name"] = GotHUD.CodeEnumResource.Name
	}
	local i = 0
	local pets = GameLib.GetPlayerPets()
	for i = 1,2,1 do
		local pet = pets[i]
		if pet ~= nil then
			local petCurr, petMax = self:GetResourceData(pet)
			for t,r in pairs(petResources) do
				local petResource = "Pet" .. i .. t
				local k = GotHUD.CodeEnumResource[petResource]
				currData[k] = petCurr[r]
				maxData[k] = petMax[r]
			end
		else
			for t,r in pairs(petResources) do
				local petResource = "Pet" .. i .. t
				local k = GotHUD.CodeEnumResource[petResource]
				currData[k] = 0
				maxData[k] = 0 -- new change, if no targetunit is selected, the HUD will disappear
			end
		end
	end
	return currData, maxData
end
function GotHUD:OnChangeWorld()
	self.playerUnit = nil
	self.targetUnit = nil
end

function GotHUD:OnEnteredCombat(unitChecked, bInCombat)
	if unitChecked == GameLib.GetPlayerUnit() then
		self.playerInCombat = bInCombat
	end
end

function GotHUD:ShouldHudBeVisible(hud,currData,maxData)
	if userSettings.disable then
		return false
	end

	if self.wndMain ~= nil and self.wndMain:IsShown() then
		return true
	end

	if hud.show == GotHUD.CodeEnumShowHUD.Never then
		return false
	end
	if hud.show == GotHUD.CodeEnumShowHUD.InCombatOnly and not self.playerInCombat then
		return false
	end	
	if hud.show == GotHUD.CodeEnumShowHUD.OutCombatOnly and self.playerInCombat then
		return false
	end	
	
	-- new change if it has no max value the unit is "gone" and the HUD should disappear
	if maxData[hud.resource] == nil or currData[hud.resource] == nil or maxData[hud.resource] == 0 then
		return false
	end
--	if maxData[hud.resource] == 0 then
--		return false
--	end
	
	-- if this is text information don't perform the arithmetic
	if tonumber(maxData[hud.resource]) ~= maxData[hud.resource] or tonumber(currData[hud.resource]) ~= currData[hud.resource] then
		return true
	end
	
	local percent = currData[hud.resource] / maxData[hud.resource]
	if (percent > hud.hideAbove) or (percent < hud.hideBelow) then
		return false
	end
	return true	
end

function GotHUD:IsHudHorizontal(hud)
	return string.match(hud.style[1],"Horizontal")
end

function GotHUD:OnFrame()

	-- make sure the playerUnit is good
	if self.playerUnit == nil then
		self.playerUnit = GameLib.GetPlayerUnit()
		if self.playerUnit == nil then
			self.targetUnit = nil
		end
	end
	if self.playerUnit ~= nil and not self.playerUnit:IsValid() then
		self.playerUnit = nil 
		self.targetUnit = nil
	end
	if self.playerUnit == nil then
		return
	end

	if self.playerUnit ~= nil then
		self.targetUnit = self.playerUnit:GetTarget()
	end
	
	if userSettings.hudTable ~=  nil then
	
		local hud = nil
		local currData,maxData = self:GetResourceData(self.playerUnit)
		currData,maxData = self:AppendTargetData(currData,maxData)
		local classID = self.playerUnit:GetClassId()
		if classID == GameLib.CodeEnumClass.Engineer or classID == GameLib.CodeEnumClass.Esper then
			currData,maxData = self:AppendPetData(currData,maxData)
		end
		
		-- this is first done in ascending alphabetical order by hud name
		for _,name in ipairs(userSettings.hudOrder) do 
		
			local hud = userSettings.hudTable[name]
			-- window creation is moved here so the layering can work
		    if hud.wnd == nil then
				--[[ Hack to work around the fact that SetStyleEx doesn't work
					hud.wnd:FindChild("ProgressBar"):SetStyleEx("VerticallyAligned",false)
					hud.wnd:FindChild("ProgressBar"):SetStyleEx("BRtoLT",false)
				--]]
				if self:IsHudHorizontal(hud) then
				    hud.wnd = Apollo.LoadForm("GotHUD.xml", "HUD_Horizontal", nil, self)
				else
				    hud.wnd = Apollo.LoadForm("GotHUD.xml", "HUD_Vertical", nil, self)
				end
				if hud.rotation ~= 0 then
					hud.wnd:SetRotation(hud.rotation)
				end
				self:UpdateLockHighlight(hud)
				hud.wnd:ToFront()
			end

			if self:ShouldHudBeVisible(hud,currData,maxData) then
				local percent = 1.0
				local val = currData[hud.resource]
				local max = maxData[hud.resource]

				local test = tonumber(max) -- test == max makes sure max is at least a number and not a text resource
				if test == max and test ~= 0 and val ~= nil and max ~= nil then
					percent = 1.0 * val / max
					if hud.discreteThreshold > 0 then
						if percent < hud.discreteThreshold then
							val = 0
							percent = 0.0
						else
							val = max
							percent = 1.0
						end
					end
				end
				if val == nil or max == nil then
					val = 0
					max = 0
					percent = 0
				end

				local color = cassPkg.gradient(hud.colorFull, hud.colorEmpty, percent)
				
				if hud.style[2] ~= nil then
					self:SetBarVars("ProgressBar", hud.wnd,val,max)
					hud.wnd:FindChild("ProgressBar"):SetBarColor(color)  
				    hud.wnd:FindChild("ProgressBar"):SetFillSprite(hud.style[2])
					hud.wnd:FindChild("ProgressBar"):SetFullSprite(hud.style[2])
				end
				if hud.style[3] ~= nil then
					hud.wnd:FindChild("Frame"):SetSprite(hud.style[3])
					hud.wnd:FindChild("Frame"):SetOpacity(hud.style[4])
					hud.wnd:FindChild("Frame"):Show(true,true)
					hud.wnd:FindChild("Frame"):SetBGColor(hud.colorFrame)
				else
					hud.wnd:FindChild("Frame"):Show(false,true)
				end
				hud.wnd:SetOpacity(hud.opacity)
				
				local left = GotHUD.CodeEnumOffsets[1] + hud.horizontalOffset
				local top = GotHUD.CodeEnumOffsets[2] + hud.verticalOffset 
				local right = GotHUD.CodeEnumOffsets[3] + hud.horizontalOffset
				local bottom = GotHUD.CodeEnumOffsets[4] + hud.verticalOffset 
				hud.wnd:SetAnchorOffsets(left,top,right,bottom) 

				if hud.showText then
					left = GotHUD.CodeEnumTextOffsets[1] + hud.horizontalOffsetText
					top = GotHUD.CodeEnumTextOffsets[2] + hud.verticalOffsetText
					right = GotHUD.CodeEnumTextOffsets[3] + hud.horizontalOffsetText
					bottom = GotHUD.CodeEnumTextOffsets[4] + hud.verticalOffsetText
					hud.wnd:FindChild("Text"):SetAnchorOffsets(left,top,right,bottom) 
					hud.wnd:FindChild("Text"):SetText(self:FormatText(percent,currData[hud.resource],hud.textFormat))
					hud.wnd:FindChild("Text"):SetFont(hud.textFont)
					hud.wnd:FindChild("Text"):SetTextColor(hud.colorText)
					hud.wnd:FindChild("Text"):Show(true,true)
				else
					hud.wnd:FindChild("Text"):SetText("")
					hud.wnd:FindChild("Text"):Show(false,true)
				end
												
				hud.wnd:SetScale(hud.scale)

				hud.wnd:SetStyle("Moveable",hud.lock == false)
				hud.wnd:Show(true,true)
				
			else
			
				if hud.wnd ~= nil then
					hud.wnd:Show(false,true)
				end
				
			end		
		end
		
	end
end


function GotHUD:OnSave(eType)
	if eType ~= GameLib.CodeEnumAddonSaveLevel.Character then return end
    local tSave = {}
	tSave.disable = userSettings.disable
	tSave.fadeSettings = userSettings.fadeSettings
	for _,hud in ipairs(userSettings.hudTable) do 
		hud.wnd = nil
	end
	tSave.hudTable = cassPkg.deepcopy(userSettings.hudTable)
	return tSave
end

function GotHUD:SetHUDDefaultParameters(name)
    for k,v in pairs(GotHUD.TemplateHUD) do 
		if userSettings.hudTable[name][k] == nil then
			userSettings.hudTable[name][k] = v
		end
	end
end
function GotHUD:OnRestore(eType, t)  
	if eType ~= GameLib.CodeEnumAddonSaveLevel.Character then return end
	userSettings.disable = t.disable
	userSettings.fadeSettings = t.fadeSettings 

	if t.fadeSettings ~= nil then
		userSettings.fadeSettings = t.fadeSettings 
	else
		userSettings.fadeSettings = defaultSettings.fadeSettings 
	end	
	
	-- restore it in the correct layering order
	local hudTable = nil
	if t.hudTable ~= nil then
		hudTable = t.hudTable
	else
		hudTable = GotHUD.DefaultHUD
	end
	
	userSettings.hudTable = {}
	userSettings.hudOrder = {}
	local count = 0
	-- go through each HUD to make sure all options exists (this is essential upon the first 
	-- load after an upgrade where new settings are introduced
    for name,hud in cassPkg.spairs(hudTable) do 
		userSettings.hudTable[name] = cassPkg.deepcopy(hud)
		count = count + 1
		userSettings.hudOrder[count] = name		
		self:SetHUDDefaultParameters(name)
	end
end

function GotHUD:OnConfigure()
	self:OnGotHUDOn()
end
-- on SlashCommand "/gothud"
function GotHUD:OnGotHUDOn()
	self:SetupLoadHUDList()
	local name, hud	
	local count = 0
    for name,hud in cassPkg.spairs(userSettings.hudTable) do 
		count = count + 1
		if count == 1 then	
			self:SetupLoadHUD(name) 
		end
	end
	self.wndMain:FindChild("Button_FadeSettings"):SetCheck(userSettings.fadeSettings)
    for name,hud in cassPkg.spairs(userSettings.hudTable) do 
		self:UpdateLockHighlight(hud)
	end
	self.wndMain:ToFront()
	self.wndMain:Show(true,true)
end


-----------------------------------------------------------------------------------------------
-- GotHUDForm Functions
-----------------------------------------------------------------------------------------------
-- when the Cancel button is clicked
function GotHUD:OnCancel()
	self.wndMain:Show(false) -- hide the window
end

function GotHUD:Button_ShowHUD( wndHandler, wndControl, eMouseButton )
	local h = userSettings.hudTable[self.editHud]
	if self.wndMain:FindChild("Button_showAlways"):IsChecked() then
		h.show = GotHUD.CodeEnumShowHUD.Always
	elseif self.wndMain:FindChild("Button_showNever"):IsChecked() then
		h.show = GotHUD.CodeEnumShowHUD.Never
	elseif self.wndMain:FindChild("Button_showInCombatOnly"):IsChecked() then
		h.show = GotHUD.CodeEnumShowHUD.InCombatOnly
	elseif self.wndMain:FindChild("Button_showCombatOnly"):IsChecked() then
		h.show = GotHUD.CodeEnumShowHUD.OutCombatOnly
	end
end

function GotHUD:SetupLoadHUDList()
	local wndGrid = self.wndMain:FindChild("Grid_HUD")
	wndGrid:DeleteAll()
	for name,hud in cassPkg.spairs(userSettings.hudTable) do	
		local i = wndGrid:AddRow(name)
	end
	self.wndMain:FindChild("HUDEditorFrame"):Enable(wndGrid:GetRowCount() > 0)
end

function GotHUD:SetSliderValue(sliderName,value,isPercent,roundDigits)
	local scrubValue = value
	local scrubText = value
	if isPercent then
		scrubValue = cassPkg.round(value * 100, roundDigits)
		scrubText = scrubValue ..  " %"
	else
		scrubValue = cassPkg.round(value, roundDigits)
		scrubText = scrubValue
	end
	self.wndMain:FindChild("Slider_" .. sliderName):SetValue(scrubValue)
	self.wndMain:FindChild("Label_" .. sliderName .. "Value"):SetText(scrubText)
end

function GotHUD:SetupLoadHUD(name)
	self.editHud = name
	local h = userSettings.hudTable[name]
	
	self.wndMain:FindChild("EditBox_HUDName"):SetText(name)
	local comboStyle = self.wndMain:FindChild("ComboBox_Style")
	comboStyle:DeleteAll()
	for _,style in cassPkg.spairs(GotHUD.HUDStyles,function(t,a,b) return t[b][1] > t[a][1] end) do 
		comboStyle:AddItem(style[1])
	end
	comboStyle:SelectItemByText(h.style[1])

	local comboResource = self.wndMain:FindChild("ComboBox_Resource")
	comboResource:DeleteAll()
	for _,resource in cassPkg.spairs(GotHUD.CodeEnumResourceStrings,function(t,a,b) return t[b] > t[a] end) do 
		comboResource:AddItem(resource)
	end
	comboResource:SelectItemByText(GotHUD.CodeEnumResourceStrings[h.resource])
	
	self.wndMain:FindChild("Button_lock"):SetCheck(h.lock)
	self.wndMain:FindChild("Button_showAlways"):SetCheck(h.show == GotHUD.CodeEnumShowHUD.Always)
	self.wndMain:FindChild("Button_showNever"):SetCheck(h.show == GotHUD.CodeEnumShowHUD.Never)
	self.wndMain:FindChild("Button_showInCombatOnly"):SetCheck(h.show == GotHUD.CodeEnumShowHUD.InCombatOnly)
	self.wndMain:FindChild("Button_showCombatOnly"):SetCheck(h.show == GotHUD.CodeEnumShowHUD.OutCombatOnly)
	
	self:SetSliderValue("hideAbove",h.hideAbove, true, 0)
	self:SetSliderValue("hideBelow",h.hideBelow, true, 0)
	self:SetSliderValue("scale",h.scale, true, 0)
	self:SetSliderValue("verticalOffset",h.verticalOffset, false, 0)
	self:SetSliderValue("horizontalOffset",h.horizontalOffset, false, 0)
	self:SetSliderValue("rotation",h.rotation, false, 0)
	self:SetSliderValue("opacity",h.opacity, true, 0)
	self:SetSliderValue("discreteThreshold",h.discreteThreshold, true, 0)
	
	self.wndMain:FindChild("Button_showText"):SetCheck(h.showText)
	self.wndMain:FindChild("Button_textFormatPercent"):SetCheck(h.textFormat == GotHUD.CodeEnumTextFormat.Percent)
	self.wndMain:FindChild("Button_textFormatDecimal"):SetCheck(h.textFormat == GotHUD.CodeEnumTextFormat.Decimal)
	self.wndMain:FindChild("Button_textFormatRaw"):SetCheck(h.textFormat == GotHUD.CodeEnumTextFormat.Raw)
	self.wndMain:FindChild("Button_textFormatUnit"):SetCheck(h.textFormat == GotHUD.CodeEnumTextFormat.Unit)
	self:SetSliderValue("verticalOffsetText",h.verticalOffsetText, false, 0)
	self:SetSliderValue("horizontalOffsetText",h.horizontalOffsetText, false, 0)
	
	local gameFonts = Apollo.GetGameFonts()
	local comboFont = self.wndMain:FindChild("ComboBox_TextFont")
	comboFont:DeleteAll()
	for _,font in cassPkg.spairs(gameFonts,function(t,a,b) return t[b].name > t[a].name end) do 
		if not comboFont:HasItem(font.name) then
			comboFont:AddItem(font.name)
		end
	end
	comboFont:SelectItemByText(h.textFont)
	self.wndMain:FindChild("colorText"):SetBGColor(h.colorText)

	self.wndMain:FindChild("colorFull"):SetBGColor(h.colorFull)
	self.wndMain:FindChild("colorEmpty"):SetBGColor(h.colorEmpty)
	self.wndMain:FindChild("colorFrame"):SetBGColor(h.colorFrame)
	
end

function GotHUD:OnStyleChanged( wndHandler, wndControl )
	local comboStyle = self.wndMain:FindChild("ComboBox_Style")
	local h = userSettings.hudTable[self.editHud]
	for _,style in ipairs(GotHUD.HUDStyles) do 
		if style[1] == comboStyle:GetSelectedText() then
			h.style = style
			if h.wnd ~= nil then
				h.wnd:Destroy()
				h.wnd = nil
			end
			break
		end
	end
end

function GotHUD:OnResourceChanged( wndHandler, wndControl )
	local comboResource = self.wndMain:FindChild("ComboBox_Resource")
	local h = userSettings.hudTable[self.editHud]
	for i,resource in pairs(GotHUD.CodeEnumResourceStrings) do 
		if resource == comboResource:GetSelectedText() then
			h.resource = i
			break
		end
	end
end


function GotHUD:OnFontChanged( wndHandler, wndControl )
	local h = userSettings.hudTable[self.editHud]
	h.textFont = self.wndMain:FindChild("ComboBox_TextFont"):GetSelectedText()
	--[[
	local gameFonts = Apollo.GetGameFonts()
	for _,font in pairs(gameFonts) do 
		if font.name == comboFont:GetSelectedText() then
			break
		end
	end
	--]]
end
function GotHUD:Slider_BarChanged( wndHandler, wndControl, fNewValue, fOldValue )
	local h = userSettings.hudTable[self.editHud]
	local setting = string.sub(wndControl:GetName(),8) -- setting name is after Slider_
	local percent = true
	if string.match(setting,"Offset") or string.match(setting,"rotation") then
		percent = false
		h[setting] = fNewValue
		if string.match(setting,"rotation") then -- make this happen immediately, doing it in OnFrame is buggy
			h.wnd:SetRotation(h.rotation)
		end
	else
		h[setting] = cassPkg.round(fNewValue / 100,2)
	end
	self:SetSliderValue(setting,h[setting],percent,0)
end

function GotHUD:OnColorUpdate()
	if colorPickerSetting ~= nil and colorPickerColor ~= nil then
		userSettings.hudTable[GotHUD.self.editHud][colorPickerSetting] = cassPkg.convertCColorToString(colorPickerColor)
		GotHUD.self:SetupLoadHUD(GotHUD.self.editHud)
	end
end

function GotHUD:LaunchColorPicker(colorSetting)
	colorPickerColor = cassPkg.convertStringToCColor(userSettings.hudTable[self.editHud][colorSetting])
	colorPickerSetting = colorSetting
	if ColorPicker then ColorPicker.AdjustCColor(colorPickerColor, false, self.OnColorUpdate) end
end

function GotHUD:Button_ColorChange( wndHandler, wndControl, eMouseButton, nLastRelativeMouseX, nLastRelativeMouseY )
	self:LaunchColorPicker(wndControl:GetName())
end

function GotHUD:EditBox_HUDNameChanged( wndHandler, wndControl, strText )
	if userSettings.hudTable[strText] == nil then
		userSettings.hudTable[strText] = cassPkg.deepcopy(userSettings.hudTable[self.editHud])
		userSettings.hudTable[self.editHud] = nil

		self:ResequenceHUDOrder()
		
		self:SetupLoadHUDList()
		self:SetupLoadHUD(strText)
	end
end

function GotHUD:GetNextHUDName(base)
	local name = base
	local copy = 0
	while userSettings.hudTable[name] ~= nil do
		copy = copy + 1
		name = base .. "(" .. copy .. ")"
	end
	return name
end

function GotHUD:ResequenceHUDOrder()
	-- now hide and destroy all the windows so the layers is preserved
	local hudTable = userSettings.hudTable
	userSettings.hudTable = {}
	userSettings.hudOrder = {}
	local count = 0
	for name, hud in cassPkg.spairs(hudTable) do
		if hud.wnd ~= nil then
			hud.wnd:Destroy()
			hud.wnd = nil
		end
		userSettings.hudTable[name] = cassPkg.deepcopy(hud)
		count = count + 1
		userSettings.hudOrder[count] = name		
	end
	if self.wndMain ~= nil and self.wndMain:IsShown() then
		self.wndMain:ToFront()
	end
end

function GotHUD:ButtonAddHUD( wndHandler, wndControl, eMouseButton )
	local name = self:GetNextHUDName("New HUD")
	userSettings.hudTable[name] = cassPkg.deepcopy(GotHUD.TemplateHUD)
	self:ResequenceHUDOrder()
	self:SetupLoadHUDList()
	self:SetupLoadHUD(name)
end

function GotHUD:Button_CopyHUD( wndHandler, wndControl, eMouseButton )
	if self.editHud ~= nil then
		local name = self:GetNextHUDName(self.editHud)

		-- don't copy the window handle, we hide the window because we don't want OnFrame to create another copy
		local h = userSettings.hudTable[self.editHud]
		local wnd = h.wnd
		local show = h.show
		h.show = GotHUD.CodeEnumShowHUD.Never
		h.wnd = nil
		
		userSettings.hudTable[name] = cassPkg.deepcopy(userSettings.hudTable[self.editHud])
		
		-- restore the settings after the copy
		h.wnd = wnd
		h.show = show
		userSettings.hudTable[name].show = show
		
		self:ResequenceHUDOrder()
		self:SetupLoadHUDList()
		self:SetupLoadHUD(name)
	end
end

function GotHUD:RemoveHUD(name)
	local h = userSettings.hudTable[name]
	h.show = GotHUD.CodeEnumShowHUD.Never
	if h.wnd ~= nil then
		h.wnd:Show(false,true)
	end
	userSettings.hudTable[name] = nil
end

function GotHUD:Button_RemoveHUD( wndHandler, wndControl, eMouseButton )
	self:RemoveHUD(self.editHud)
	self:ResequenceHUDOrder()
	self:SetupLoadHUDList()
	local wndGrid = self.wndMain:FindChild("Grid_HUD") 
	if wndGrid:GetRowCount() > 0 then
		wndGrid:SelectCell(1,1)
		local row = wndGrid:GetCurrentRow()
		local name = wndGrid:GetCellText(row)
		self:SetupLoadHUD(name)
	else
		self.wndMain:Show(false,true)
	end
end

function GotHUD:Button_RecreateStandardHUD( wndHandler, wndControl, eMouseButton )
    for name,hud in pairs(GotHUD.DefaultHUD) do
		-- if there is another hud present named as a default
		local cur = userSettings.hudTable[name]
		if cur ~= nil then
			self:RemoveHUD(name)
		end
		userSettings.hudTable[name] = cassPkg.deepcopy(hud)
	end 
	self:SetupLoadHUDList()
	local wndGrid = self.wndMain:FindChild("Grid_HUD") 
	wndGrid:SelectCell(1,1)
	local row = wndGrid:GetCurrentRow()
	local name = wndGrid:GetCellText(row)
	self:ResequenceHUDOrder()
	self:SetupLoadHUD(name)
end

function GotHUD:OnHUDClick( wndHandler, wndControl, eMouseButton, nLastRelativeMouseX, nLastRelativeMouseY )
	local wndGrid = self.wndMain:FindChild("Grid_HUD") 
	local row = wndGrid:GetCurrentRow()
	if row ~= nil and row <= wndGrid:GetRowCount() then
		local name = wndGrid:GetCellText(row)
		self:SetupLoadHUD(name)
	end
end

function GotHUD:Button_ShowText( wndHandler, wndControl, eMouseButton )
	userSettings.hudTable[self.editHud].showText = self.wndMain:FindChild("Button_showText"):IsChecked()
end

function GotHUD:Button_TextFormat( wndHandler, wndControl, eMouseButton )
	local h = userSettings.hudTable[self.editHud]
	if self.wndMain:FindChild("Button_textFormatPercent"):IsChecked() then
		h.textFormat = GotHUD.CodeEnumTextFormat.Percent
	elseif self.wndMain:FindChild("Button_textFormatDecimal"):IsChecked() then
		h.textFormat = GotHUD.CodeEnumTextFormat.Decimal
	elseif self.wndMain:FindChild("Button_textFormatRaw"):IsChecked() then
		h.textFormat = GotHUD.CodeEnumTextFormat.Raw
	elseif self.wndMain:FindChild("Button_textFormatUnit"):IsChecked() then
		h.textFormat = GotHUD.CodeEnumTextFormat.Unit
	end
end

function GotHUD:Slider_MouseDown( wndHandler, wndControl, eMouseButton, nLastRelativeMouseX, nLastRelativeMouseY, bDoubleClick, bStopPropagation )
	local h = userSettings.hudTable[self.editHud]
	local setting = string.sub(wndControl:GetName(),8) -- setting name is after Slider_
	local unit = 0.01
	local percent = true
	if string.match(setting,"Offset") or string.match(setting,"rotation") then
		unit = 1
		percent = false
	end
	if eMouseButton == 0 then
		h[setting] = h[setting] - unit 
	else
		h[setting] = h[setting] + unit 
	end
	self:SetSliderValue(setting,h[setting],percent, 0)
end

function GotHUD:UpdateLockHighlight(hud)
	if hud.wnd ~= nil then
		if not hud.lock and self.wndMain ~= nil and self.wndMain:IsShown() then
			hud.wnd:SetSprite("CRB_ChallengeSprites:sprCh_RFlashBase")
			hud.wnd:SetBGColor("white")
		else 
			hud.wnd:SetSprite("")
			hud.wnd:SetBGColor("00000000")
		end
	end
end
function GotHUD:Button_LockHUD( wndHandler, wndControl, eMouseButton )
	local locked = self.wndMain:FindChild("Button_lock"):IsChecked()
	userSettings.hudTable[self.editHud].lock = locked
	self:UpdateLockHighlight(userSettings.hudTable[self.editHud])
end
function GotHUD:ButtonImport( wndHandler, wndControl, eMouseButton )
	if self.wndPopup == nil then
		self.wndPopup = Apollo.LoadForm(self.xmlDoc, "PopupForm", nil, self)
	end
	self.wndPopup:FindChild("Prompt"):SetText("Paste into the field below your HUD settings string. Any existing HUD named the same will be replaced.")
	self.wndPopup:FindChild("EditBox"):SetText("")
	self.wndPopup:FindChild("Button"):Show(true,true)
	self.wndPopup:Show(true,false)
	self.wndPopup:ToFront()
end

function GotHUD:ButtonExport( wndHandler, wndControl, eMouseButton )
	local exportHud = cassPkg.deepcopy(userSettings.hudTable)
	for _,hud in ipairs(exportHud ) do 
		hud.wnd = nil
	end
	local exportString = cassPkg.SaveTable(exportHud)
	if self.wndPopup == nil then
		self.wndPopup = Apollo.LoadForm(self.xmlDoc, "PopupForm", nil, self)
	end
	self.wndPopup:FindChild("Prompt"):SetText("Below is your HUD settings export string, use Ctrl+C to copy it to your system clipboard.")
	self.wndPopup:FindChild("EditBox"):SetText(exportString)
	self.wndPopup:FindChild("Button"):Show(false,true)
	self.wndPopup:Show(true,false)
	self.wndPopup:ToFront()
	self.wndPopup:FindChild("EditBox"):SetFocus()
end

function GotHUD:OnOptionsWindowClosed( wndHandler, wndControl )
    for name,hud in pairs(userSettings.hudTable) do 
		if hud.wnd ~= nil then
			hud.wnd:SetSprite("")
			hud.wnd:SetBGColor("FFFFFFFF")
		end
	end
end

function GotHUD:OnMouseExit( wndHandler, wndControl, x, y )
	if userSettings.fadeSettings and wndControl == self.wndMain then
		self.wndMain:SetOpacity(0.10,2.0)
	end
end

function GotHUD:OnMouseEnter( wndHandler, wndControl, x, y )
	if userSettings.fadeSettings then
		self.wndMain:SetOpacity(1.0,2.0)
	end
end

function GotHUD:Button_FadeSettings( wndHandler, wndControl, eMouseButton )
	userSettings.fadeSettings = self.wndMain:FindChild("Button_FadeSettings"):IsChecked()
end

---------------------------------------------------------------------------------------------------
-- HUD_Horizontal Functions
---------------------------------------------------------------------------------------------------

function GotHUD:OnHUDMove( wndHandler, wndControl, nOldLeft, nOldTop, nOldRight, nOldBottom )
	for _,hud in cassPkg.spairs(userSettings.hudTable) do 
		if wndControl == hud.wnd and not hud.lock then
			local left,top,_,_ = hud.wnd:GetAnchorOffsets()
			hud.horizontalOffset = left - GotHUD.CodeEnumOffsets[1]
			hud.verticalOffset = top - GotHUD.CodeEnumOffsets[2]
			if self.wndMain:IsShown() then
				self:SetupLoadHUD(self.editHud) -- even if this isn't the one being moved, it will update correctly
			end
			break			
		end
	end	
end

---------------------------------------------------------------------------------------------------
-- PopupForm Functions
---------------------------------------------------------------------------------------------------

function GotHUD:OnImportButton( wndHandler, wndControl, eMouseButton )
	local importString = self.wndPopup:FindChild("EditBox"):GetText()
	self.wndPopup:Show(false,true)
	local importHud = cassPkg.LoadTable(importString)
	if importHud ~= nil then
		for name,hud in cassPkg.spairs(importHud) do 
			local newName = name
			local cur = userSettings.hudTable[name]
			if cur ~= nil then
				newName = self:GetNextHUDName(name)
			end
			userSettings.hudTable[newName] = cassPkg.deepcopy(hud)
			-- convert older hud import strings to add new default parameters
			self:SetHUDDefaultParameters(newName)
		end	
		self:ResequenceHUDOrder()
		self:SetupLoadHUDList()
		local wndGrid = self.wndMain:FindChild("Grid_HUD") 
		wndGrid:SelectCell(1,1)
		local row = wndGrid:GetCurrentRow()
		local name = wndGrid:GetCellText(row)
		self:SetupLoadHUD(name)
	else
		Print("failed to import settings")
	end	
end

function GotHUD:OnPopupCloseButton( wndHandler, wndControl, eMouseButton )
	self.wndPopup:Show(false,true)
end

-----------------------------------------------------------------------------------------------
-- GotHUD Instance
-----------------------------------------------------------------------------------------------
local GotHUDInst = GotHUD:new()
GotHUDInst:Init()


